import { HighlightManager, type HighlightManagerOptions, type HighlightHandlers, type Highlight } from "./HighlightManager.js";
import { type DomAnchor } from "./anchors/index.js";
export type DomAnchorHighlightManagerOptions<Data> = Omit<HighlightManagerOptions<DomAnchor, Data>, "getRangesFromAnchor">;
/** A HighlightManager with a predetermined Anchor type. */
export declare class DomAnchorHighlightManager<Data> extends HighlightManager<DomAnchor, Data> {
    constructor(options: DomAnchorHighlightManagerOptions<Data>);
    createHighlightFromCurrentSelection(data: Data, handlers?: HighlightHandlers<Data>): Highlight<DomAnchor, Data>;
    createHighlightFromSelection(selection: Selection, data: Data, handlers?: HighlightHandlers<Data>): Highlight<DomAnchor, Data>;
    createHighlightFromRange(range: Range, data: Data, handlers?: HighlightHandlers<Data>): Highlight<DomAnchor, Data>;
}
